import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { ifNotIn, completeFromList } from '@codemirror/autocomplete';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,permit:14, forbid:16, is:22, in:32, when:44, unless:46, true:50, false:50, has:66, like:68, if:70, then:72, else:74, contains:76, containsAll:78, principal:218, action:220, resource:222, context:224};
const parser = LRParser.deserialize({
  version: 14,
  states: "5rQYQPOOOeQPO'#DgOOQO'#D]'#D]OYQPO'#C_OjQPO'#C_QYQPOOOOQO'#Dj'#DjOOQO'#D['#D[OoQPO,5:ROOQO-E7Z-E7ZOtQPO,58yOyQQO,58yOOQO-E7Y-E7YO!OQPO1G/mOyQQO1G.eO!TQPO'#DlOOQO'#Cf'#CfO!cQPO'#DkOOQO'#Ce'#CeO!hQPO1G.eO!mQPO7+%XO!rQPO7+$POOQO'#Cj'#CjO!wQPO,5:WO#PQPO'#DuO!wQPO,5:WOOQO,5:W,5:WO#UQQO,5:VO#ZQPO7+$POOQO<<Hs<<HsO#fQPO<<GkO#qQPO'#ChOOQO'#D^'#D^O#vQPO,5:bOOQO1G/r1G/rO$OQPO,5:aO$TQPO,5:cO$]QPO'#DoOOQO'#Cn'#CnO$hQPO1G/qOOQO'#D`'#D`O#fQPO<<GkOOQO<<Gk<<GkO$mQPO'#DyO$rQPOAN=VOOQOAN=VAN=VOOQO,59S,59SOOQO-E7[-E7[OOQO1G/|1G/|O$}QPO1G/{OOQO1G/}1G/}O#PQPO'#DvO%YQPO,5:ZOOQO,5:Z,5:ZO%bQQO7+%]OOQO-E7^-E7^O%gQPO,5:eOOQOG22qG22qO#PQPO'#DqOOQO1G/u1G/uO&eQPO'#DsOOQO'#Cq'#CqOOQO<<Hw<<HwO&sQPO'#DzO&{QPO'#DqOOQO'#D{'#D{OOQO'#D|'#D|O(eQSO1G0PO%gQPO'#E[O(lQPO'#EiOOQO'#DV'#DVOOQO'#DW'#DWOOQO'#DX'#DXOOQO'#DY'#DYOOQO'#Dz'#DzO(tQPO'#EcO(yQPO'#DrO)RQPO,5:]OOQO,5:_,5:_O)WQPO,5:_O)WQPO,5:_O)`QPO,5;QOOQO,5:f,5:fO)hQPO'#EhO)pQPO,5;ROOQO'#Cw'#CwOOQO'#Cx'#CxOOQO'#Cy'#CyOOQO'#Cz'#CzOOQO'#C{'#C{O%gQPO,5:kO%gQPO,5:kO%gQPO,5:kO%gQPO,5:kO%gQPO,5:kO%gQPO,5:uO)uQPO,5:wO%gQPO,5:zO*QQPO,5:xO#PQPO,5:yO*YQPO,5:|OOQO7+%k7+%kO*_QSO,5:vO*fQQO'#EkO*kQPO'#EjO*sQPO,5;TO*xQPO,5:}O*}QPO,5:^OOQO1G/w1G/wOOQO1G/y1G/yO%gQPO1G0lO+VQPO'#DbO+bQPO,5;SOOQO1G0m1G0mOOQO1G0V1G0VO,zQSO1G0VO-UQSO1G0VO.sQSO1G0VO.zQSO1G0VO/RQSO1G0aOOQO1G0c1G0cO/YQPO1G0jO/_QPO1G0kO/dQSO'#EaO/nQPO1G0fOOQO1G0d1G0dO/sQPO1G0eOOQO1G0h1G0hOOQO1G0b1G0bO+VQPO,5;VO(lQPO'#DcO/xQPO,5;UOOQO1G0o1G0oOOQO1G0i1G0iO0QQPO1G/xO#PQPO'#D_O0YQPO7+&WOOQO,59|,59|OOQO-E7`-E7`OOQO7+%{7+%{O%gQPO7+&UO%gQPO7+&VO%gQPO'#DaO0_QPO,5:{OOQO7+&Q7+&QO0gQSO7+&POOQO1G0q1G0qOOQO,59},59}OOQO-E7a-E7aOOQO-E7]-E7]O2QQPO,59yOOQO<<Ir<<IrO2YQSO<<IpO2aQSO<<IqO2hQSO,59{OOQO-E7_-E7_OOQO1G/e1G/eOOQOAN?[AN?[OOQOAN?]AN?]",
  stateData: "2r~O!YOSPOS~OVUOWUO![PO~O!]WO~OSZO~OS]O~OS^O~O!a_O~OTdO~OZhO_fO`iOa!`X~OakO~OUlO~OUmO~OUnO~O!]oO!brO~O!]oO~O!duO~Of{Og{O}zO~Of{Og{O}}O~O]!OO~OT!QO!]oO~O!]!RO~OT!SO!]oO~O_fO`!UOa!cX~Oa!WO~Oh!YO~Of{Og{O}!ZO~O]!OOa!iiU!ii~Oc![O!]oO~O!h!^O~OS!fOT!cOc!bOh!gOi!cOj!cOs!mO!]oO!q!dO!r!dO#a!hO#b!iO#c!jO#d!kO~OZhO_fO`!rOU!gX~OT!tO!]!sO~OT!cOi!cOj!cO!]oO~OS#TOZ#VO_!yO`#OOc#ROp#SOq#UOr#WO!q!xO!t!wO!u!xO!v!yO!w!yO!x!yO!y!yO!z!yO!{!zO!|!{O~Ox#XO~P'ZOT#ZO!]#ZO~Ot#^O~OT#_O!]oO~Od#`O~O!]oO!l#aO~OS#bO]!OO~Oa#cOd#[X~Od#eO~Ov#mOw#nO!]#lO~OT#qO!]#qO~OT#sO~OU#tO~P'ZO#`#uO~Oa#vOx#^X~Ox#xO~Ou#yO~Oa#{Od!fa~OT!cOi!cOj!cO~Oa#cOd#[a~O!t!wOS!siZ!si_!si`!sic!sip!siq!sir!six!si!v!si!w!si!x!si!y!si!z!si!{!si!|!siU!sid!sia!si~O!q!si!u!si~P+jO!q!xO!u!xO~P+jO_!yO`#OO!q!xO!t!wO!u!xO!v!yO!w!yO!x!yO!y!yO!z!yOS!siZ!sic!sip!siq!sir!six!si!|!siU!sid!sia!si~O!{!si~P-`O!{!zO~P-`Od$PO~P'ZOS$QO~OS$RO~Oa$SOU#TX~P'ZOU$UO~O!]$VO~Oa#vOx#^a~Oa#{Od!fi~OU$]O~Oa$SOU#Ta~O]!OOS#RqZ#Rq_#Rq`#Rqc#Rqp#Rqq#Rqr#Rqx#Rq!q#Rq!t#Rq!u#Rq!v#Rq!w#Rq!x#Rq!y#Rq!z#Rq!{#Rq!|#RqU#Rqd#Rqa#Rq~OT$bO!]oO~OU$cO~P'ZOU$dO~P'ZOU!Taa!Ta~P'ZO",
  goto: "+g#`PPP#aPPPPP#e#kP#oP$bPPP$kPP$nPPPPP$q%O%[%g%qPPPPPPPPP%z%z%z%zP&Z&a&h'i'o'y(P(VPPP(]PP(b(i(mPP(qP(t)W)[P)_)e)eP)n)t*k%zPP%zPPPPPPPPP%z%z%z%z%z%z+T%z%z%z%z%z%z+Z%z+^+aTVOTQcZRe^TaZ^!apghiqst!T!U!Y![!a!b!f!n!q!r!|!}#O#P#Q#R#T#V#b#r#{$Q$R$S$[Qg_Q!TuR!q!^RwkR!`!Wg!|!e#Y#g#h#i#j#k#o$^$_$`e!}!e#Y#h#i#j#k#o$^$_$`c#O!e#Y#i#j#k#o$^$_$`a#P!e#Y#j#k#o$^$_$`_#Q!e#Y#k#o$^$_$`k!l!Y!f!|!}#O#P#Q#R#T#b$Q$R$SQTOR[TSROTRXRUqg!T!qQshUti!U!r^!Pqst!a!n#r$[j!a!Y!f!|!}#O#P#Q#R#T#b$Q$R$SS!n![!bQ#r#VR$[#{Q#z#_R$Z#zQylQ|nT!Xy|Q$T#oR$a$TQ#d!uR$O#dQ#w#[R$Y#wVQORTSSOTRYRTbZ^T`Z^RvkQ!]!Uk!l!Y!f!|!}#O#P#Q#R#T#b$Q$R$ST!o![!bR!_!WQj_R!p!^Qj_Q!VuR!p!^Xxlny|Q!e!YQ#Y!fQ#f!|Q#g!}Q#h#OQ#i#PQ#j#QQ#k#RS#o#T#bQ$^$QQ$_$RR$`$Sj!l!Y!f!|!}#O#P#Q#R#T#b$Q$R$SQ!u!bQ#}#cR$W#uQ#p#TR#|#bR!v!bR#]!gQ#[!gR$X#v",
  nodeNames: "⚠ LineComment Program Policy ( String ) permit forbid Scope PrincipalConstraint is Namespace :: CompareOp == in , ActionConstraint [ ] ResourceConstraint when unless { BooleanLiteral Int ArithOp ArithOp CompareOp LogicOp LogicOp . has like if then else contains containsAll } Principal Action Resource Context ;",
  maxTerm: 112,
  nodeProps: [
    ["isolate", 1,""]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 8,
  tokenData: ">P~RxXY#oYZ#o]^#opq#oqr$Qrs$_tu%{vw&pxy&{yz'Qz{'V{|'[|}'a}!O'f!O!P'k!P!Q'p!Q![(_![!](g!]!^(t!^!_(y!_!`)W!`!a)c!a!b)p!b!c,R!c!}%{!}#O,W#P#Q,]#R#S%{#T#U,b#U#d%{#d#e0x#e#f%{#f#g7j#g#o%{#o#p=j#p#q=o#q#r=z$g;'S%{;'S;=`&j<%lO%{~#tS!Y~XY#oYZ#o]^#opq#oT$VP!rP!_!`$YS$_O!zS~$bVOr$_rs$ws#O$_#O#P$|#P;'S$_;'S;=`%u<%lO$_~$|OT~~%PRO;'S$_;'S;=`%Y;=`O$_~%]WOr$_rs$ws#O$_#O#P$|#P;'S$_;'S;=`%u;=`<%l$_<%lO$_~%xP;=`<%l$_T&QW!]Ttu%{!Q![%{!c!}%{#R#S%{#T#o%{$g;'S%{;'S;=`&j<%lO%{T&mP;=`<%l%{~&sPvw&v~&{O!{~~'QOS~~'VOU~~'[O!t~~'aO!u~~'fOa~~'kO!q~~'pOp~~'sP!P!Q'v~'{SP~OY'vZ;'S'v;'S;=`(X<%lO'v~([P;=`<%l'v~(dPj~!Q![(_V(lP#`Q![!](oT(tO]T~(yO}~~)OP!v~!_!`)R~)WO!w~~)ZP!_!`)^~)cO_~~)hP!y~!_!`)k~)pO!x~~)sQ#d#e)y#f#g+Q~)|P#f#g*P~*SP#]#^*V~*YP#b#c*]~*`P#V#W*c~*fP#]#^*i~*lP#d#e*o~*rP#T#U*u~*xP#`#a*{~+QO!b~~+TP#X#Y+W~+ZP#g#h+^~+aP#c#d+d~+gP#i#j+j~+mP#f#g+p~+sP#V#W+v~+yP#X#Y+|~,RO!l~~,WO![~~,]Oc~~,bOd~V,gY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#V%{#V#W-V#W#o%{$g;'S%{;'S;=`&j<%lO%{V-[Y!]Ttu%{!Q![%{!c!}%{#R#S%{#T#h%{#h#i-z#i#o%{$g;'S%{;'S;=`&j<%lO%{V.PY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#]%{#]#^.o#^#o%{$g;'S%{;'S;=`&j<%lO%{V.tY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#c%{#c#d/d#d#o%{$g;'S%{;'S;=`&j<%lO%{V/iY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#b%{#b#c0X#c#o%{$g;'S%{;'S;=`&j<%lO%{V0`W!dQ!]Ttu%{!Q![%{!c!}%{#R#S%{#T#o%{$g;'S%{;'S;=`&j<%lO%{V0}Y!]Ttu%{!Q![%{!c!}%{#R#S%{#T#f%{#f#g1m#g#o%{$g;'S%{;'S;=`&j<%lO%{V1rY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#]%{#]#^2b#^#o%{$g;'S%{;'S;=`&j<%lO%{V2gY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#b%{#b#c3V#c#o%{$g;'S%{;'S;=`&j<%lO%{V3[Y!]Ttu%{!Q![%{!c!}%{#R#S%{#T#V%{#V#W3z#W#o%{$g;'S%{;'S;=`&j<%lO%{V4PY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#]%{#]#^4o#^#o%{$g;'S%{;'S;=`&j<%lO%{V4tY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#d%{#d#e5d#e#o%{$g;'S%{;'S;=`&j<%lO%{V5iX!]Ttu%{!Q![%{!c!}%{#R#S%{#T#U6U#U#o%{$g;'S%{;'S;=`&j<%lO%{V6ZY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#`%{#`#a6y#a#o%{$g;'S%{;'S;=`&j<%lO%{V7QW!aQ!]Ttu%{!Q![%{!c!}%{#R#S%{#T#o%{$g;'S%{;'S;=`&j<%lO%{V7oY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#X%{#X#Y8_#Y#o%{$g;'S%{;'S;=`&j<%lO%{V8dY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#g%{#g#h9S#h#o%{$g;'S%{;'S;=`&j<%lO%{V9XY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#c%{#c#d9w#d#o%{$g;'S%{;'S;=`&j<%lO%{V9|Y!]Ttu%{!Q![%{!c!}%{#R#S%{#T#i%{#i#j:l#j#o%{$g;'S%{;'S;=`&j<%lO%{V:qY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#f%{#f#g;a#g#o%{$g;'S%{;'S;=`&j<%lO%{V;fY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#V%{#V#W<U#W#o%{$g;'S%{;'S;=`&j<%lO%{V<ZY!]Ttu%{!Q![%{!c!}%{#R#S%{#T#X%{#X#Y<y#Y#o%{$g;'S%{;'S;=`&j<%lO%{V=QW!hQ!]Ttu%{!Q![%{!c!}%{#R#S%{#T#o%{$g;'S%{;'S;=`&j<%lO%{~=oOh~~=rP#p#q=u~=zO!|~~>POx~",
  tokenizers: [0, 1, 2],
  topRules: {"Program":[0,2]},
  specialized: [{term: 59, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 0
});

let kwCompletion = (name) => ({ label: name, type: "keyword" });
const keywords = "permit forbid when unless".split(" ").map(kwCompletion);
const dontComplete = ["String", "LineComment"];
const cedarLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Effect: tags.definitionKeyword,
                "permit forbid": tags.definitionKeyword,
                "when unless": tags.keyword,
                "in is has contains containsAll": tags.operatorKeyword,
                "if then else": tags.controlKeyword,
                Identifier: tags.variableName,
                CompareOp: tags.compareOperator,
                BooleanLiteral: tags.bool,
                Principal: tags.variableName,
                Action: tags.variableName,
                Resource: tags.variableName,
                Context: tags.variableName,
                String: tags.string,
                Int: tags.integer,
                LineComment: tags.lineComment,
                "( )": tags.paren,
                "{ }": tags.brace,
                "[ ]": tags.squareBracket,
                ";": tags.separator,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: "//" },
    },
});
function cedar() {
    return new LanguageSupport(cedarLanguage, [
        cedarLanguage.data.of({
            autocomplete: ifNotIn(dontComplete, completeFromList(keywords)),
        }),
    ]);
}

export { cedar, cedarLanguage };
